<template>
  <div class="container h-100 d-flex justify-content-center align-items-center">
    <div class="col-lg-8">
      <h1 class="text-center mb-4">Expenses to pay</h1>
    
      <table class="table table-striped">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Title</th>
            <th scope="col">Description</th>
            <th scope="col">Date</th>
            <th scope="col">Amount</th>
            <th scope="col">Your balance</th>
            <th scope="col">Status</th>
            <th scope="col">Actions</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(expense, index) in expenses" :key="expense.id">
            <th scope="row">{{ index + 1 }}</th>
            <td>{{ expense.title }}</td>
            <td>{{ expense.description }}</td>
            <td>{{ expense.date }}</td>
            <td>{{ expense.amount }}</td>
            <td>{{ expense.balance }}</td>
            <td :class="{ 'text-danger': expense.status === 'unpaid', 'text-success': expense.status === 'paid' }">{{ expense.status }}</td>
            <td>
              <button class="btn btn-primary" @click="selectedExpense = expense; showModal = true">View</button>
              <button class="btn btn-success" @click="payExpense(expense)">Pay</button>
            </td>
          </tr>
        </tbody>
      </table>
      <!-- Modal -->
      <div class="modal" v-if="selectedExpense" :class="{ 'd-block': showModal, 'show': showModal }" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Expense Details</h5>
              <button type="button" class="close" @click="showModal = false">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p><strong>Title:</strong> {{ selectedExpense.title }}</p>
              <p><strong>Description:</strong> {{ selectedExpense.description }}</p>
              <p><strong>Date:</strong> {{ selectedExpense.date }}</p>
              <p><strong>Amount:</strong> {{ selectedExpense.amount }}</p>
              <p><strong>Your balance:</strong> {{ selectedExpense.balance }}</p>
              <p><strong>Status:</strong> {{ selectedExpense.status }}</p>
              <!-- Add a list or table here to display the members of the group attached to the expense -->
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" @click="showModal = false">Close</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { GET_EXPENSES_OF_USERS, PAY_EXPENSE, GET_GROUP_KEYS } from "../api/api.js";
import JSEncrypt from 'jsencrypt';
import CryptoJS from 'crypto-js';
export default {
  name: 'HomeView',
  data() {
    return {
      expenses: [],
      showModal: false,
      selectedExpense: null,
      currentUser: JSON.parse(sessionStorage.getItem('token')), // You should fetch the expenses from your API and assign them to this array
    }
  },
  methods:{
    fetchExpenses() {
      const userId = JSON.parse(sessionStorage.getItem("token")).id;
      GET_EXPENSES_OF_USERS(userId)
        .then((data) => {
          // this.expenses = data;
          // console.log(data);
           // Decrypt the expenses
      const decryptedExpenses = data.map(expense => {
        // Fetch the group keys for the group of the expense
        return GET_GROUP_KEYS(expense.groupId)
          .then((response) => {
            const groupKeys = response.groupKeys;
            const userGroupKey = groupKeys.find(key => key.userId === this.currentUser.id);
            if(userGroupKey){
              const crypt = new JSEncrypt();
              const privateKey = localStorage.getItem('privateKey');
              crypt.setPrivateKey(privateKey);
              const decryptedGroupKey = crypt.decrypt(userGroupKey.encryptedKey);
              // Decrypt the expense data with the decrypted group key
              return {
                ...expense,
                title: CryptoJS.AES.decrypt(expense.title, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                description: CryptoJS.AES.decrypt(expense.description, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                date: CryptoJS.AES.decrypt(expense.date, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                // The amount is not encrypted
                amount: expense.amount,
              };
            } else {
              console.error('No decrypted key found for the group of the expense');
              return expense;
            }
          });
      });
      // Wait for all expenses to be decrypted
      Promise.all(decryptedExpenses).then((expenses) => {
        this.expenses = expenses;
        console.log(expenses);
      });
        })
        .catch((e) => {
          console.log(e);
        });
    },
    payExpense(expense) {
      if (window.confirm('Are you sure you want to pay this expense?')) {
        const userId = JSON.parse(sessionStorage.getItem("token")).id;
        PAY_EXPENSE(expense.id, userId)
          .then(() => {
            expense.status = 'paid';
          })
          .catch((e) => {
            console.log(e);
          });
      }
    }
  },
  mounted(){
    this.fetchExpenses()
  }
}
</script>

<style scoped>
.container {
  height: 100vh; /* Full height of the viewport */
}
</style>